# google-sheets-ti
Reads and writes Google Sheets.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v4
- Package version: 0.0.1
- Generator version: 7.11.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://google.com](https://google.com)

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import google_sheets_ti
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import google_sheets_ti
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import google_sheets_ti
from google_sheets_ti.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://sheets.googleapis.com
# See configuration.py for a list of all supported configuration parameters.
configuration = google_sheets_ti.Configuration(
    host = "https://sheets.googleapis.com"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

configuration.access_token = os.environ["ACCESS_TOKEN"]

configuration.access_token = os.environ["ACCESS_TOKEN"]


# Enter a context with an instance of the API client
with google_sheets_ti.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = google_sheets_ti.SpreadsheetsApi(api_client)
    spreadsheet_id = 'spreadsheet_id_example' # str | The spreadsheet to apply the updates to.
    access_token = 'access_token_example' # str | OAuth access token. (optional)
    alt = json # str | Data format for response. (optional) (default to json)
    param_callback = 'param_callback_example' # str | JSONP (optional)
    fields = 'fields_example' # str | Selector specifying which fields to include in a partial response. (optional)
    key = 'key_example' # str | API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. (optional)
    oauth_token = 'oauth_token_example' # str | OAuth 2.0 token for the current user. (optional)
    pretty_print = True # bool | Returns response with indentations and line breaks. (optional) (default to True)
    quota_user = 'quota_user_example' # str | Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. (optional)
    upload_protocol = 'upload_protocol_example' # str | Upload protocol for media (e.g. \"raw\", \"multipart\"). (optional)
    upload_type = 'upload_type_example' # str | Legacy upload protocol for media (e.g. \"media\", \"multipart\"). (optional)
    xgafv = 'xgafv_example' # str | V1 error format. (optional)
    batch_update_spreadsheet_request = google_sheets_ti.BatchUpdateSpreadsheetRequest() # BatchUpdateSpreadsheetRequest |  (optional)

    try:
        api_response = api_instance.sheets_spreadsheets_batch_update(spreadsheet_id, access_token=access_token, alt=alt, param_callback=param_callback, fields=fields, key=key, oauth_token=oauth_token, pretty_print=pretty_print, quota_user=quota_user, upload_protocol=upload_protocol, upload_type=upload_type, xgafv=xgafv, batch_update_spreadsheet_request=batch_update_spreadsheet_request)
        print("The response of SpreadsheetsApi->sheets_spreadsheets_batch_update:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling SpreadsheetsApi->sheets_spreadsheets_batch_update: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://sheets.googleapis.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SpreadsheetsApi* | [**sheets_spreadsheets_batch_update**](docs/SpreadsheetsApi.md#sheets_spreadsheets_batch_update) | **POST** /v4/spreadsheets/{spreadsheetId}:batchUpdate | 
*SpreadsheetsApi* | [**sheets_spreadsheets_create**](docs/SpreadsheetsApi.md#sheets_spreadsheets_create) | **POST** /v4/spreadsheets | 
*SpreadsheetsApi* | [**sheets_spreadsheets_developer_metadata_get**](docs/SpreadsheetsApi.md#sheets_spreadsheets_developer_metadata_get) | **GET** /v4/spreadsheets/{spreadsheetId}/developerMetadata/{metadataId} | 
*SpreadsheetsApi* | [**sheets_spreadsheets_developer_metadata_search**](docs/SpreadsheetsApi.md#sheets_spreadsheets_developer_metadata_search) | **POST** /v4/spreadsheets/{spreadsheetId}/developerMetadata:search | 
*SpreadsheetsApi* | [**sheets_spreadsheets_get**](docs/SpreadsheetsApi.md#sheets_spreadsheets_get) | **GET** /v4/spreadsheets/{spreadsheetId} | 
*SpreadsheetsApi* | [**sheets_spreadsheets_get_by_data_filter**](docs/SpreadsheetsApi.md#sheets_spreadsheets_get_by_data_filter) | **POST** /v4/spreadsheets/{spreadsheetId}:getByDataFilter | 
*SpreadsheetsApi* | [**sheets_spreadsheets_sheets_copy_to**](docs/SpreadsheetsApi.md#sheets_spreadsheets_sheets_copy_to) | **POST** /v4/spreadsheets/{spreadsheetId}/sheets/{sheetId}:copyTo | 
*SpreadsheetsApi* | [**sheets_spreadsheets_values_append**](docs/SpreadsheetsApi.md#sheets_spreadsheets_values_append) | **POST** /v4/spreadsheets/{spreadsheetId}/values/{range}:append | 
*SpreadsheetsApi* | [**sheets_spreadsheets_values_batch_clear**](docs/SpreadsheetsApi.md#sheets_spreadsheets_values_batch_clear) | **POST** /v4/spreadsheets/{spreadsheetId}/values:batchClear | 
*SpreadsheetsApi* | [**sheets_spreadsheets_values_batch_clear_by_data_filter**](docs/SpreadsheetsApi.md#sheets_spreadsheets_values_batch_clear_by_data_filter) | **POST** /v4/spreadsheets/{spreadsheetId}/values:batchClearByDataFilter | 
*SpreadsheetsApi* | [**sheets_spreadsheets_values_batch_get**](docs/SpreadsheetsApi.md#sheets_spreadsheets_values_batch_get) | **GET** /v4/spreadsheets/{spreadsheetId}/values:batchGet | 
*SpreadsheetsApi* | [**sheets_spreadsheets_values_batch_get_by_data_filter**](docs/SpreadsheetsApi.md#sheets_spreadsheets_values_batch_get_by_data_filter) | **POST** /v4/spreadsheets/{spreadsheetId}/values:batchGetByDataFilter | 
*SpreadsheetsApi* | [**sheets_spreadsheets_values_batch_update**](docs/SpreadsheetsApi.md#sheets_spreadsheets_values_batch_update) | **POST** /v4/spreadsheets/{spreadsheetId}/values:batchUpdate | 
*SpreadsheetsApi* | [**sheets_spreadsheets_values_batch_update_by_data_filter**](docs/SpreadsheetsApi.md#sheets_spreadsheets_values_batch_update_by_data_filter) | **POST** /v4/spreadsheets/{spreadsheetId}/values:batchUpdateByDataFilter | 
*SpreadsheetsApi* | [**sheets_spreadsheets_values_clear**](docs/SpreadsheetsApi.md#sheets_spreadsheets_values_clear) | **POST** /v4/spreadsheets/{spreadsheetId}/values/{range}:clear | 
*SpreadsheetsApi* | [**sheets_spreadsheets_values_get**](docs/SpreadsheetsApi.md#sheets_spreadsheets_values_get) | **GET** /v4/spreadsheets/{spreadsheetId}/values/{range} | 
*SpreadsheetsApi* | [**sheets_spreadsheets_values_update**](docs/SpreadsheetsApi.md#sheets_spreadsheets_values_update) | **PUT** /v4/spreadsheets/{spreadsheetId}/values/{range} | 


## Documentation For Models

 - [AddBandingRequest](docs/AddBandingRequest.md)
 - [AddBandingResponse](docs/AddBandingResponse.md)
 - [AddChartRequest](docs/AddChartRequest.md)
 - [AddChartResponse](docs/AddChartResponse.md)
 - [AddConditionalFormatRuleRequest](docs/AddConditionalFormatRuleRequest.md)
 - [AddDataSourceRequest](docs/AddDataSourceRequest.md)
 - [AddDataSourceResponse](docs/AddDataSourceResponse.md)
 - [AddDimensionGroupRequest](docs/AddDimensionGroupRequest.md)
 - [AddDimensionGroupResponse](docs/AddDimensionGroupResponse.md)
 - [AddFilterViewRequest](docs/AddFilterViewRequest.md)
 - [AddFilterViewResponse](docs/AddFilterViewResponse.md)
 - [AddNamedRangeRequest](docs/AddNamedRangeRequest.md)
 - [AddNamedRangeResponse](docs/AddNamedRangeResponse.md)
 - [AddProtectedRangeRequest](docs/AddProtectedRangeRequest.md)
 - [AddProtectedRangeResponse](docs/AddProtectedRangeResponse.md)
 - [AddSheetRequest](docs/AddSheetRequest.md)
 - [AddSheetResponse](docs/AddSheetResponse.md)
 - [AddSlicerRequest](docs/AddSlicerRequest.md)
 - [AddSlicerResponse](docs/AddSlicerResponse.md)
 - [AppendCellsRequest](docs/AppendCellsRequest.md)
 - [AppendDimensionRequest](docs/AppendDimensionRequest.md)
 - [AppendValuesResponse](docs/AppendValuesResponse.md)
 - [AutoFillRequest](docs/AutoFillRequest.md)
 - [AutoResizeDimensionsRequest](docs/AutoResizeDimensionsRequest.md)
 - [BandedRange](docs/BandedRange.md)
 - [BandingProperties](docs/BandingProperties.md)
 - [BaselineValueFormat](docs/BaselineValueFormat.md)
 - [BasicChartAxis](docs/BasicChartAxis.md)
 - [BasicChartDomain](docs/BasicChartDomain.md)
 - [BasicChartSeries](docs/BasicChartSeries.md)
 - [BasicChartSpec](docs/BasicChartSpec.md)
 - [BasicFilter](docs/BasicFilter.md)
 - [BasicSeriesDataPointStyleOverride](docs/BasicSeriesDataPointStyleOverride.md)
 - [BatchClearValuesByDataFilterRequest](docs/BatchClearValuesByDataFilterRequest.md)
 - [BatchClearValuesByDataFilterResponse](docs/BatchClearValuesByDataFilterResponse.md)
 - [BatchClearValuesRequest](docs/BatchClearValuesRequest.md)
 - [BatchClearValuesResponse](docs/BatchClearValuesResponse.md)
 - [BatchGetValuesByDataFilterRequest](docs/BatchGetValuesByDataFilterRequest.md)
 - [BatchGetValuesByDataFilterResponse](docs/BatchGetValuesByDataFilterResponse.md)
 - [BatchGetValuesResponse](docs/BatchGetValuesResponse.md)
 - [BatchUpdateSpreadsheetRequest](docs/BatchUpdateSpreadsheetRequest.md)
 - [BatchUpdateSpreadsheetResponse](docs/BatchUpdateSpreadsheetResponse.md)
 - [BatchUpdateValuesByDataFilterRequest](docs/BatchUpdateValuesByDataFilterRequest.md)
 - [BatchUpdateValuesByDataFilterResponse](docs/BatchUpdateValuesByDataFilterResponse.md)
 - [BatchUpdateValuesRequest](docs/BatchUpdateValuesRequest.md)
 - [BatchUpdateValuesResponse](docs/BatchUpdateValuesResponse.md)
 - [BigQueryDataSourceSpec](docs/BigQueryDataSourceSpec.md)
 - [BigQueryQuerySpec](docs/BigQueryQuerySpec.md)
 - [BigQueryTableSpec](docs/BigQueryTableSpec.md)
 - [BooleanCondition](docs/BooleanCondition.md)
 - [BooleanRule](docs/BooleanRule.md)
 - [Border](docs/Border.md)
 - [Borders](docs/Borders.md)
 - [BubbleChartSpec](docs/BubbleChartSpec.md)
 - [CancelDataSourceRefreshRequest](docs/CancelDataSourceRefreshRequest.md)
 - [CancelDataSourceRefreshResponse](docs/CancelDataSourceRefreshResponse.md)
 - [CancelDataSourceRefreshStatus](docs/CancelDataSourceRefreshStatus.md)
 - [CandlestickChartSpec](docs/CandlestickChartSpec.md)
 - [CandlestickData](docs/CandlestickData.md)
 - [CandlestickDomain](docs/CandlestickDomain.md)
 - [CandlestickSeries](docs/CandlestickSeries.md)
 - [CellData](docs/CellData.md)
 - [CellFormat](docs/CellFormat.md)
 - [ChartAxisViewWindowOptions](docs/ChartAxisViewWindowOptions.md)
 - [ChartCustomNumberFormatOptions](docs/ChartCustomNumberFormatOptions.md)
 - [ChartData](docs/ChartData.md)
 - [ChartDateTimeRule](docs/ChartDateTimeRule.md)
 - [ChartGroupRule](docs/ChartGroupRule.md)
 - [ChartHistogramRule](docs/ChartHistogramRule.md)
 - [ChartSourceRange](docs/ChartSourceRange.md)
 - [ChartSpec](docs/ChartSpec.md)
 - [ClearBasicFilterRequest](docs/ClearBasicFilterRequest.md)
 - [ClearValuesResponse](docs/ClearValuesResponse.md)
 - [Color](docs/Color.md)
 - [ColorStyle](docs/ColorStyle.md)
 - [ConditionValue](docs/ConditionValue.md)
 - [ConditionalFormatRule](docs/ConditionalFormatRule.md)
 - [CopyPasteRequest](docs/CopyPasteRequest.md)
 - [CopySheetToAnotherSpreadsheetRequest](docs/CopySheetToAnotherSpreadsheetRequest.md)
 - [CreateDeveloperMetadataRequest](docs/CreateDeveloperMetadataRequest.md)
 - [CreateDeveloperMetadataResponse](docs/CreateDeveloperMetadataResponse.md)
 - [CutPasteRequest](docs/CutPasteRequest.md)
 - [DataExecutionStatus](docs/DataExecutionStatus.md)
 - [DataFilter](docs/DataFilter.md)
 - [DataFilterValueRange](docs/DataFilterValueRange.md)
 - [DataLabel](docs/DataLabel.md)
 - [DataSource](docs/DataSource.md)
 - [DataSourceChartProperties](docs/DataSourceChartProperties.md)
 - [DataSourceColumn](docs/DataSourceColumn.md)
 - [DataSourceColumnReference](docs/DataSourceColumnReference.md)
 - [DataSourceFormula](docs/DataSourceFormula.md)
 - [DataSourceObjectReference](docs/DataSourceObjectReference.md)
 - [DataSourceObjectReferences](docs/DataSourceObjectReferences.md)
 - [DataSourceParameter](docs/DataSourceParameter.md)
 - [DataSourceRefreshDailySchedule](docs/DataSourceRefreshDailySchedule.md)
 - [DataSourceRefreshMonthlySchedule](docs/DataSourceRefreshMonthlySchedule.md)
 - [DataSourceRefreshSchedule](docs/DataSourceRefreshSchedule.md)
 - [DataSourceRefreshWeeklySchedule](docs/DataSourceRefreshWeeklySchedule.md)
 - [DataSourceSheetDimensionRange](docs/DataSourceSheetDimensionRange.md)
 - [DataSourceSheetProperties](docs/DataSourceSheetProperties.md)
 - [DataSourceSpec](docs/DataSourceSpec.md)
 - [DataSourceTable](docs/DataSourceTable.md)
 - [DataValidationRule](docs/DataValidationRule.md)
 - [DateTimeRule](docs/DateTimeRule.md)
 - [DeleteBandingRequest](docs/DeleteBandingRequest.md)
 - [DeleteConditionalFormatRuleRequest](docs/DeleteConditionalFormatRuleRequest.md)
 - [DeleteConditionalFormatRuleResponse](docs/DeleteConditionalFormatRuleResponse.md)
 - [DeleteDataSourceRequest](docs/DeleteDataSourceRequest.md)
 - [DeleteDeveloperMetadataRequest](docs/DeleteDeveloperMetadataRequest.md)
 - [DeleteDeveloperMetadataResponse](docs/DeleteDeveloperMetadataResponse.md)
 - [DeleteDimensionGroupRequest](docs/DeleteDimensionGroupRequest.md)
 - [DeleteDimensionGroupResponse](docs/DeleteDimensionGroupResponse.md)
 - [DeleteDimensionRequest](docs/DeleteDimensionRequest.md)
 - [DeleteDuplicatesRequest](docs/DeleteDuplicatesRequest.md)
 - [DeleteDuplicatesResponse](docs/DeleteDuplicatesResponse.md)
 - [DeleteEmbeddedObjectRequest](docs/DeleteEmbeddedObjectRequest.md)
 - [DeleteFilterViewRequest](docs/DeleteFilterViewRequest.md)
 - [DeleteNamedRangeRequest](docs/DeleteNamedRangeRequest.md)
 - [DeleteProtectedRangeRequest](docs/DeleteProtectedRangeRequest.md)
 - [DeleteRangeRequest](docs/DeleteRangeRequest.md)
 - [DeleteSheetRequest](docs/DeleteSheetRequest.md)
 - [DeveloperMetadata](docs/DeveloperMetadata.md)
 - [DeveloperMetadataLocation](docs/DeveloperMetadataLocation.md)
 - [DeveloperMetadataLookup](docs/DeveloperMetadataLookup.md)
 - [DimensionGroup](docs/DimensionGroup.md)
 - [DimensionProperties](docs/DimensionProperties.md)
 - [DimensionRange](docs/DimensionRange.md)
 - [DuplicateFilterViewRequest](docs/DuplicateFilterViewRequest.md)
 - [DuplicateFilterViewResponse](docs/DuplicateFilterViewResponse.md)
 - [DuplicateSheetRequest](docs/DuplicateSheetRequest.md)
 - [DuplicateSheetResponse](docs/DuplicateSheetResponse.md)
 - [Editors](docs/Editors.md)
 - [EmbeddedChart](docs/EmbeddedChart.md)
 - [EmbeddedObjectBorder](docs/EmbeddedObjectBorder.md)
 - [EmbeddedObjectPosition](docs/EmbeddedObjectPosition.md)
 - [ErrorValue](docs/ErrorValue.md)
 - [ExtendedValue](docs/ExtendedValue.md)
 - [FilterCriteria](docs/FilterCriteria.md)
 - [FilterSpec](docs/FilterSpec.md)
 - [FilterView](docs/FilterView.md)
 - [FindReplaceRequest](docs/FindReplaceRequest.md)
 - [FindReplaceResponse](docs/FindReplaceResponse.md)
 - [GetSpreadsheetByDataFilterRequest](docs/GetSpreadsheetByDataFilterRequest.md)
 - [GradientRule](docs/GradientRule.md)
 - [GridCoordinate](docs/GridCoordinate.md)
 - [GridData](docs/GridData.md)
 - [GridProperties](docs/GridProperties.md)
 - [GridRange](docs/GridRange.md)
 - [HistogramChartSpec](docs/HistogramChartSpec.md)
 - [HistogramRule](docs/HistogramRule.md)
 - [HistogramSeries](docs/HistogramSeries.md)
 - [InsertDimensionRequest](docs/InsertDimensionRequest.md)
 - [InsertRangeRequest](docs/InsertRangeRequest.md)
 - [InterpolationPoint](docs/InterpolationPoint.md)
 - [Interval](docs/Interval.md)
 - [IterativeCalculationSettings](docs/IterativeCalculationSettings.md)
 - [KeyValueFormat](docs/KeyValueFormat.md)
 - [LineStyle](docs/LineStyle.md)
 - [Link](docs/Link.md)
 - [LookerDataSourceSpec](docs/LookerDataSourceSpec.md)
 - [ManualRule](docs/ManualRule.md)
 - [ManualRuleGroup](docs/ManualRuleGroup.md)
 - [MatchedDeveloperMetadata](docs/MatchedDeveloperMetadata.md)
 - [MatchedValueRange](docs/MatchedValueRange.md)
 - [MergeCellsRequest](docs/MergeCellsRequest.md)
 - [MoveDimensionRequest](docs/MoveDimensionRequest.md)
 - [NamedRange](docs/NamedRange.md)
 - [NumberFormat](docs/NumberFormat.md)
 - [OrgChartSpec](docs/OrgChartSpec.md)
 - [OverlayPosition](docs/OverlayPosition.md)
 - [Padding](docs/Padding.md)
 - [PasteDataRequest](docs/PasteDataRequest.md)
 - [PieChartSpec](docs/PieChartSpec.md)
 - [PivotFilterCriteria](docs/PivotFilterCriteria.md)
 - [PivotFilterSpec](docs/PivotFilterSpec.md)
 - [PivotGroup](docs/PivotGroup.md)
 - [PivotGroupLimit](docs/PivotGroupLimit.md)
 - [PivotGroupRule](docs/PivotGroupRule.md)
 - [PivotGroupSortValueBucket](docs/PivotGroupSortValueBucket.md)
 - [PivotGroupValueMetadata](docs/PivotGroupValueMetadata.md)
 - [PivotTable](docs/PivotTable.md)
 - [PivotValue](docs/PivotValue.md)
 - [PointStyle](docs/PointStyle.md)
 - [ProtectedRange](docs/ProtectedRange.md)
 - [RandomizeRangeRequest](docs/RandomizeRangeRequest.md)
 - [RefreshCancellationStatus](docs/RefreshCancellationStatus.md)
 - [RefreshDataSourceObjectExecutionStatus](docs/RefreshDataSourceObjectExecutionStatus.md)
 - [RefreshDataSourceRequest](docs/RefreshDataSourceRequest.md)
 - [RefreshDataSourceResponse](docs/RefreshDataSourceResponse.md)
 - [RepeatCellRequest](docs/RepeatCellRequest.md)
 - [Request](docs/Request.md)
 - [Response](docs/Response.md)
 - [RowData](docs/RowData.md)
 - [ScorecardChartSpec](docs/ScorecardChartSpec.md)
 - [SearchDeveloperMetadataRequest](docs/SearchDeveloperMetadataRequest.md)
 - [SearchDeveloperMetadataResponse](docs/SearchDeveloperMetadataResponse.md)
 - [SetBasicFilterRequest](docs/SetBasicFilterRequest.md)
 - [SetDataValidationRequest](docs/SetDataValidationRequest.md)
 - [Sheet](docs/Sheet.md)
 - [SheetProperties](docs/SheetProperties.md)
 - [Slicer](docs/Slicer.md)
 - [SlicerSpec](docs/SlicerSpec.md)
 - [SortRangeRequest](docs/SortRangeRequest.md)
 - [SortSpec](docs/SortSpec.md)
 - [SourceAndDestination](docs/SourceAndDestination.md)
 - [Spreadsheet](docs/Spreadsheet.md)
 - [SpreadsheetProperties](docs/SpreadsheetProperties.md)
 - [SpreadsheetTheme](docs/SpreadsheetTheme.md)
 - [TextFormat](docs/TextFormat.md)
 - [TextFormatRun](docs/TextFormatRun.md)
 - [TextPosition](docs/TextPosition.md)
 - [TextRotation](docs/TextRotation.md)
 - [TextToColumnsRequest](docs/TextToColumnsRequest.md)
 - [ThemeColorPair](docs/ThemeColorPair.md)
 - [TimeOfDay](docs/TimeOfDay.md)
 - [TreemapChartColorScale](docs/TreemapChartColorScale.md)
 - [TreemapChartSpec](docs/TreemapChartSpec.md)
 - [TrimWhitespaceRequest](docs/TrimWhitespaceRequest.md)
 - [TrimWhitespaceResponse](docs/TrimWhitespaceResponse.md)
 - [UnmergeCellsRequest](docs/UnmergeCellsRequest.md)
 - [UpdateBandingRequest](docs/UpdateBandingRequest.md)
 - [UpdateBordersRequest](docs/UpdateBordersRequest.md)
 - [UpdateCellsRequest](docs/UpdateCellsRequest.md)
 - [UpdateChartSpecRequest](docs/UpdateChartSpecRequest.md)
 - [UpdateConditionalFormatRuleRequest](docs/UpdateConditionalFormatRuleRequest.md)
 - [UpdateConditionalFormatRuleResponse](docs/UpdateConditionalFormatRuleResponse.md)
 - [UpdateDataSourceRequest](docs/UpdateDataSourceRequest.md)
 - [UpdateDataSourceResponse](docs/UpdateDataSourceResponse.md)
 - [UpdateDeveloperMetadataRequest](docs/UpdateDeveloperMetadataRequest.md)
 - [UpdateDeveloperMetadataResponse](docs/UpdateDeveloperMetadataResponse.md)
 - [UpdateDimensionGroupRequest](docs/UpdateDimensionGroupRequest.md)
 - [UpdateDimensionPropertiesRequest](docs/UpdateDimensionPropertiesRequest.md)
 - [UpdateEmbeddedObjectBorderRequest](docs/UpdateEmbeddedObjectBorderRequest.md)
 - [UpdateEmbeddedObjectPositionRequest](docs/UpdateEmbeddedObjectPositionRequest.md)
 - [UpdateEmbeddedObjectPositionResponse](docs/UpdateEmbeddedObjectPositionResponse.md)
 - [UpdateFilterViewRequest](docs/UpdateFilterViewRequest.md)
 - [UpdateNamedRangeRequest](docs/UpdateNamedRangeRequest.md)
 - [UpdateProtectedRangeRequest](docs/UpdateProtectedRangeRequest.md)
 - [UpdateSheetPropertiesRequest](docs/UpdateSheetPropertiesRequest.md)
 - [UpdateSlicerSpecRequest](docs/UpdateSlicerSpecRequest.md)
 - [UpdateSpreadsheetPropertiesRequest](docs/UpdateSpreadsheetPropertiesRequest.md)
 - [UpdateValuesByDataFilterResponse](docs/UpdateValuesByDataFilterResponse.md)
 - [UpdateValuesResponse](docs/UpdateValuesResponse.md)
 - [ValueRange](docs/ValueRange.md)
 - [WaterfallChartColumnStyle](docs/WaterfallChartColumnStyle.md)
 - [WaterfallChartCustomSubtotal](docs/WaterfallChartCustomSubtotal.md)
 - [WaterfallChartDomain](docs/WaterfallChartDomain.md)
 - [WaterfallChartSeries](docs/WaterfallChartSeries.md)
 - [WaterfallChartSpec](docs/WaterfallChartSpec.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="Oauth2"></a>
### Oauth2

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://accounts.google.com/o/oauth2/auth
- **Scopes**: 
 - **https://www.googleapis.com/auth/drive**: See, edit, create, and delete all of your Google Drive files
 - **https://www.googleapis.com/auth/drive.file**: See, edit, create, and delete only the specific Google Drive files you use with this app
 - **https://www.googleapis.com/auth/drive.readonly**: See and download all your Google Drive files
 - **https://www.googleapis.com/auth/spreadsheets**: See, edit, create, and delete all your Google Sheets spreadsheets
 - **https://www.googleapis.com/auth/spreadsheets.readonly**: See all your Google Sheets spreadsheets

<a id="Oauth2c"></a>
### Oauth2c

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://accounts.google.com/o/oauth2/auth
- **Scopes**: 
 - **https://www.googleapis.com/auth/drive**: See, edit, create, and delete all of your Google Drive files
 - **https://www.googleapis.com/auth/drive.file**: See, edit, create, and delete only the specific Google Drive files you use with this app
 - **https://www.googleapis.com/auth/drive.readonly**: See and download all your Google Drive files
 - **https://www.googleapis.com/auth/spreadsheets**: See, edit, create, and delete all your Google Sheets spreadsheets
 - **https://www.googleapis.com/auth/spreadsheets.readonly**: See all your Google Sheets spreadsheets


## Author




