# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.grid_range import GridRange
from google_sheets_ti.models.source_and_destination import SourceAndDestination
from typing import Optional, Set
from typing_extensions import Self

class AutoFillRequest(BaseModel):
    """
    Fills in more data based on existing data.
    """ # noqa: E501
    range: Optional[GridRange] = None
    source_and_destination: Optional[SourceAndDestination] = Field(default=None, alias="sourceAndDestination")
    use_alternate_series: Optional[StrictBool] = Field(default=None, description="True if we should generate data with the \"alternate\" series. This differs based on the type and amount of source data.", alias="useAlternateSeries")
    __properties: ClassVar[List[str]] = ["range", "sourceAndDestination", "useAlternateSeries"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AutoFillRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of range
        if self.range:
            _dict['range'] = self.range.to_dict()
        # override the default output from pydantic by calling `to_dict()` of source_and_destination
        if self.source_and_destination:
            _dict['sourceAndDestination'] = self.source_and_destination.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AutoFillRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "range": GridRange.from_dict(obj["range"]) if obj.get("range") is not None else None,
            "sourceAndDestination": SourceAndDestination.from_dict(obj["sourceAndDestination"]) if obj.get("sourceAndDestination") is not None else None,
            "useAlternateSeries": obj.get("useAlternateSeries")
        })
        return _obj


