# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.data_source_sheet_dimension_range import DataSourceSheetDimensionRange
from google_sheets_ti.models.dimension_range import DimensionRange
from typing import Optional, Set
from typing_extensions import Self

class AutoResizeDimensionsRequest(BaseModel):
    """
    Automatically resizes one or more dimensions based on the contents of the cells in that dimension.
    """ # noqa: E501
    data_source_sheet_dimensions: Optional[DataSourceSheetDimensionRange] = Field(default=None, alias="dataSourceSheetDimensions")
    dimensions: Optional[DimensionRange] = None
    __properties: ClassVar[List[str]] = ["dataSourceSheetDimensions", "dimensions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AutoResizeDimensionsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of data_source_sheet_dimensions
        if self.data_source_sheet_dimensions:
            _dict['dataSourceSheetDimensions'] = self.data_source_sheet_dimensions.to_dict()
        # override the default output from pydantic by calling `to_dict()` of dimensions
        if self.dimensions:
            _dict['dimensions'] = self.dimensions.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AutoResizeDimensionsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dataSourceSheetDimensions": DataSourceSheetDimensionRange.from_dict(obj["dataSourceSheetDimensions"]) if obj.get("dataSourceSheetDimensions") is not None else None,
            "dimensions": DimensionRange.from_dict(obj["dimensions"]) if obj.get("dimensions") is not None else None
        })
        return _obj


