# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.banding_properties import BandingProperties
from google_sheets_ti.models.grid_range import GridRange
from typing import Optional, Set
from typing_extensions import Self

class BandedRange(BaseModel):
    """
    A banded (alternating colors) range in a sheet.
    """ # noqa: E501
    banded_range_id: Optional[StrictInt] = Field(default=None, description="The ID of the banded range.", alias="bandedRangeId")
    column_properties: Optional[BandingProperties] = Field(default=None, alias="columnProperties")
    range: Optional[GridRange] = None
    row_properties: Optional[BandingProperties] = Field(default=None, alias="rowProperties")
    __properties: ClassVar[List[str]] = ["bandedRangeId", "columnProperties", "range", "rowProperties"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BandedRange from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of column_properties
        if self.column_properties:
            _dict['columnProperties'] = self.column_properties.to_dict()
        # override the default output from pydantic by calling `to_dict()` of range
        if self.range:
            _dict['range'] = self.range.to_dict()
        # override the default output from pydantic by calling `to_dict()` of row_properties
        if self.row_properties:
            _dict['rowProperties'] = self.row_properties.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BandedRange from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bandedRangeId": obj.get("bandedRangeId"),
            "columnProperties": BandingProperties.from_dict(obj["columnProperties"]) if obj.get("columnProperties") is not None else None,
            "range": GridRange.from_dict(obj["range"]) if obj.get("range") is not None else None,
            "rowProperties": BandingProperties.from_dict(obj["rowProperties"]) if obj.get("rowProperties") is not None else None
        })
        return _obj


