# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.matched_value_range import MatchedValueRange
from typing import Optional, Set
from typing_extensions import Self

class BatchGetValuesByDataFilterResponse(BaseModel):
    """
    The response when retrieving more than one range of values in a spreadsheet selected by DataFilters.
    """ # noqa: E501
    spreadsheet_id: Optional[StrictStr] = Field(default=None, description="The ID of the spreadsheet the data was retrieved from.", alias="spreadsheetId")
    value_ranges: Optional[List[MatchedValueRange]] = Field(default=None, description="The requested values with the list of data filters that matched them.", alias="valueRanges")
    __properties: ClassVar[List[str]] = ["spreadsheetId", "valueRanges"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BatchGetValuesByDataFilterResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in value_ranges (list)
        _items = []
        if self.value_ranges:
            for _item_value_ranges in self.value_ranges:
                if _item_value_ranges:
                    _items.append(_item_value_ranges.to_dict())
            _dict['valueRanges'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BatchGetValuesByDataFilterResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "spreadsheetId": obj.get("spreadsheetId"),
            "valueRanges": [MatchedValueRange.from_dict(_item) for _item in obj["valueRanges"]] if obj.get("valueRanges") is not None else None
        })
        return _obj


