# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.update_values_by_data_filter_response import UpdateValuesByDataFilterResponse
from typing import Optional, Set
from typing_extensions import Self

class BatchUpdateValuesByDataFilterResponse(BaseModel):
    """
    The response when updating a range of values in a spreadsheet.
    """ # noqa: E501
    responses: Optional[List[UpdateValuesByDataFilterResponse]] = Field(default=None, description="The response for each range updated.")
    spreadsheet_id: Optional[StrictStr] = Field(default=None, description="The spreadsheet the updates were applied to.", alias="spreadsheetId")
    total_updated_cells: Optional[StrictInt] = Field(default=None, description="The total number of cells updated.", alias="totalUpdatedCells")
    total_updated_columns: Optional[StrictInt] = Field(default=None, description="The total number of columns where at least one cell in the column was updated.", alias="totalUpdatedColumns")
    total_updated_rows: Optional[StrictInt] = Field(default=None, description="The total number of rows where at least one cell in the row was updated.", alias="totalUpdatedRows")
    total_updated_sheets: Optional[StrictInt] = Field(default=None, description="The total number of sheets where at least one cell in the sheet was updated.", alias="totalUpdatedSheets")
    __properties: ClassVar[List[str]] = ["responses", "spreadsheetId", "totalUpdatedCells", "totalUpdatedColumns", "totalUpdatedRows", "totalUpdatedSheets"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BatchUpdateValuesByDataFilterResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in responses (list)
        _items = []
        if self.responses:
            for _item_responses in self.responses:
                if _item_responses:
                    _items.append(_item_responses.to_dict())
            _dict['responses'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BatchUpdateValuesByDataFilterResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "responses": [UpdateValuesByDataFilterResponse.from_dict(_item) for _item in obj["responses"]] if obj.get("responses") is not None else None,
            "spreadsheetId": obj.get("spreadsheetId"),
            "totalUpdatedCells": obj.get("totalUpdatedCells"),
            "totalUpdatedColumns": obj.get("totalUpdatedColumns"),
            "totalUpdatedRows": obj.get("totalUpdatedRows"),
            "totalUpdatedSheets": obj.get("totalUpdatedSheets")
        })
        return _obj


