# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.big_query_query_spec import BigQueryQuerySpec
from google_sheets_ti.models.big_query_table_spec import BigQueryTableSpec
from typing import Optional, Set
from typing_extensions import Self

class BigQueryDataSourceSpec(BaseModel):
    """
    The specification of a BigQuery data source that's connected to a sheet.
    """ # noqa: E501
    project_id: Optional[StrictStr] = Field(default=None, description="The ID of a BigQuery enabled Google Cloud project with a billing account attached. For any queries executed against the data source, the project is charged.", alias="projectId")
    query_spec: Optional[BigQueryQuerySpec] = Field(default=None, alias="querySpec")
    table_spec: Optional[BigQueryTableSpec] = Field(default=None, alias="tableSpec")
    __properties: ClassVar[List[str]] = ["projectId", "querySpec", "tableSpec"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BigQueryDataSourceSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of query_spec
        if self.query_spec:
            _dict['querySpec'] = self.query_spec.to_dict()
        # override the default output from pydantic by calling `to_dict()` of table_spec
        if self.table_spec:
            _dict['tableSpec'] = self.table_spec.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BigQueryDataSourceSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "projectId": obj.get("projectId"),
            "querySpec": BigQueryQuerySpec.from_dict(obj["querySpec"]) if obj.get("querySpec") is not None else None,
            "tableSpec": BigQueryTableSpec.from_dict(obj["tableSpec"]) if obj.get("tableSpec") is not None else None
        })
        return _obj


