# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class ChartAxisViewWindowOptions(BaseModel):
    """
    The options that define a \"view window\" for a chart (such as the visible values in an axis).
    """ # noqa: E501
    view_window_max: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The maximum numeric value to be shown in this view window. If unset, will automatically determine a maximum value that looks good for the data.", alias="viewWindowMax")
    view_window_min: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The minimum numeric value to be shown in this view window. If unset, will automatically determine a minimum value that looks good for the data.", alias="viewWindowMin")
    view_window_mode: Optional[StrictStr] = Field(default=None, description="The view window's mode.", alias="viewWindowMode")
    __properties: ClassVar[List[str]] = ["viewWindowMax", "viewWindowMin", "viewWindowMode"]

    @field_validator('view_window_mode')
    def view_window_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['DEFAULT_VIEW_WINDOW_MODE', 'VIEW_WINDOW_MODE_UNSUPPORTED', 'EXPLICIT', 'PRETTY']):
            raise ValueError("must be one of enum values ('DEFAULT_VIEW_WINDOW_MODE', 'VIEW_WINDOW_MODE_UNSUPPORTED', 'EXPLICIT', 'PRETTY')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChartAxisViewWindowOptions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChartAxisViewWindowOptions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "viewWindowMax": obj.get("viewWindowMax"),
            "viewWindowMin": obj.get("viewWindowMin"),
            "viewWindowMode": obj.get("viewWindowMode")
        })
        return _obj


