# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.boolean_rule import BooleanRule
from google_sheets_ti.models.gradient_rule import GradientRule
from google_sheets_ti.models.grid_range import GridRange
from typing import Optional, Set
from typing_extensions import Self

class ConditionalFormatRule(BaseModel):
    """
    A rule describing a conditional format.
    """ # noqa: E501
    boolean_rule: Optional[BooleanRule] = Field(default=None, alias="booleanRule")
    gradient_rule: Optional[GradientRule] = Field(default=None, alias="gradientRule")
    ranges: Optional[List[GridRange]] = Field(default=None, description="The ranges that are formatted if the condition is true. All the ranges must be on the same grid.")
    __properties: ClassVar[List[str]] = ["booleanRule", "gradientRule", "ranges"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ConditionalFormatRule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of boolean_rule
        if self.boolean_rule:
            _dict['booleanRule'] = self.boolean_rule.to_dict()
        # override the default output from pydantic by calling `to_dict()` of gradient_rule
        if self.gradient_rule:
            _dict['gradientRule'] = self.gradient_rule.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in ranges (list)
        _items = []
        if self.ranges:
            for _item_ranges in self.ranges:
                if _item_ranges:
                    _items.append(_item_ranges.to_dict())
            _dict['ranges'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ConditionalFormatRule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "booleanRule": BooleanRule.from_dict(obj["booleanRule"]) if obj.get("booleanRule") is not None else None,
            "gradientRule": GradientRule.from_dict(obj["gradientRule"]) if obj.get("gradientRule") is not None else None,
            "ranges": [GridRange.from_dict(_item) for _item in obj["ranges"]] if obj.get("ranges") is not None else None
        })
        return _obj


