# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.developer_metadata_lookup import DeveloperMetadataLookup
from google_sheets_ti.models.grid_range import GridRange
from typing import Optional, Set
from typing_extensions import Self

class DataFilter(BaseModel):
    """
    Filter that describes what data should be selected or returned from a request.
    """ # noqa: E501
    a1_range: Optional[StrictStr] = Field(default=None, description="Selects data that matches the specified A1 range.", alias="a1Range")
    developer_metadata_lookup: Optional[DeveloperMetadataLookup] = Field(default=None, alias="developerMetadataLookup")
    grid_range: Optional[GridRange] = Field(default=None, alias="gridRange")
    __properties: ClassVar[List[str]] = ["a1Range", "developerMetadataLookup", "gridRange"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of developer_metadata_lookup
        if self.developer_metadata_lookup:
            _dict['developerMetadataLookup'] = self.developer_metadata_lookup.to_dict()
        # override the default output from pydantic by calling `to_dict()` of grid_range
        if self.grid_range:
            _dict['gridRange'] = self.grid_range.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "a1Range": obj.get("a1Range"),
            "developerMetadataLookup": DeveloperMetadataLookup.from_dict(obj["developerMetadataLookup"]) if obj.get("developerMetadataLookup") is not None else None,
            "gridRange": GridRange.from_dict(obj["gridRange"]) if obj.get("gridRange") is not None else None
        })
        return _obj


