# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.data_source_column import DataSourceColumn
from google_sheets_ti.models.data_source_spec import DataSourceSpec
from typing import Optional, Set
from typing_extensions import Self

class DataSource(BaseModel):
    """
    Information about an external data source in the spreadsheet.
    """ # noqa: E501
    calculated_columns: Optional[List[DataSourceColumn]] = Field(default=None, description="All calculated columns in the data source.", alias="calculatedColumns")
    data_source_id: Optional[StrictStr] = Field(default=None, description="The spreadsheet-scoped unique ID that identifies the data source. Example: 1080547365.", alias="dataSourceId")
    sheet_id: Optional[StrictInt] = Field(default=None, description="The ID of the Sheet connected with the data source. The field cannot be changed once set. When creating a data source, an associated DATA_SOURCE sheet is also created, if the field is not specified, the ID of the created sheet will be randomly generated.", alias="sheetId")
    spec: Optional[DataSourceSpec] = None
    __properties: ClassVar[List[str]] = ["calculatedColumns", "dataSourceId", "sheetId", "spec"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataSource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in calculated_columns (list)
        _items = []
        if self.calculated_columns:
            for _item_calculated_columns in self.calculated_columns:
                if _item_calculated_columns:
                    _items.append(_item_calculated_columns.to_dict())
            _dict['calculatedColumns'] = _items
        # override the default output from pydantic by calling `to_dict()` of spec
        if self.spec:
            _dict['spec'] = self.spec.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataSource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "calculatedColumns": [DataSourceColumn.from_dict(_item) for _item in obj["calculatedColumns"]] if obj.get("calculatedColumns") is not None else None,
            "dataSourceId": obj.get("dataSourceId"),
            "sheetId": obj.get("sheetId"),
            "spec": DataSourceSpec.from_dict(obj["spec"]) if obj.get("spec") is not None else None
        })
        return _obj


