# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.grid_coordinate import GridCoordinate
from typing import Optional, Set
from typing_extensions import Self

class DataSourceObjectReference(BaseModel):
    """
    Reference to a data source object.
    """ # noqa: E501
    chart_id: Optional[StrictInt] = Field(default=None, description="References to a data source chart.", alias="chartId")
    data_source_formula_cell: Optional[GridCoordinate] = Field(default=None, alias="dataSourceFormulaCell")
    data_source_pivot_table_anchor_cell: Optional[GridCoordinate] = Field(default=None, alias="dataSourcePivotTableAnchorCell")
    data_source_table_anchor_cell: Optional[GridCoordinate] = Field(default=None, alias="dataSourceTableAnchorCell")
    sheet_id: Optional[StrictStr] = Field(default=None, description="References to a DATA_SOURCE sheet.", alias="sheetId")
    __properties: ClassVar[List[str]] = ["chartId", "dataSourceFormulaCell", "dataSourcePivotTableAnchorCell", "dataSourceTableAnchorCell", "sheetId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataSourceObjectReference from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of data_source_formula_cell
        if self.data_source_formula_cell:
            _dict['dataSourceFormulaCell'] = self.data_source_formula_cell.to_dict()
        # override the default output from pydantic by calling `to_dict()` of data_source_pivot_table_anchor_cell
        if self.data_source_pivot_table_anchor_cell:
            _dict['dataSourcePivotTableAnchorCell'] = self.data_source_pivot_table_anchor_cell.to_dict()
        # override the default output from pydantic by calling `to_dict()` of data_source_table_anchor_cell
        if self.data_source_table_anchor_cell:
            _dict['dataSourceTableAnchorCell'] = self.data_source_table_anchor_cell.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataSourceObjectReference from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "chartId": obj.get("chartId"),
            "dataSourceFormulaCell": GridCoordinate.from_dict(obj["dataSourceFormulaCell"]) if obj.get("dataSourceFormulaCell") is not None else None,
            "dataSourcePivotTableAnchorCell": GridCoordinate.from_dict(obj["dataSourcePivotTableAnchorCell"]) if obj.get("dataSourcePivotTableAnchorCell") is not None else None,
            "dataSourceTableAnchorCell": GridCoordinate.from_dict(obj["dataSourceTableAnchorCell"]) if obj.get("dataSourceTableAnchorCell") is not None else None,
            "sheetId": obj.get("sheetId")
        })
        return _obj


