# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.data_execution_status import DataExecutionStatus
from google_sheets_ti.models.data_source_column import DataSourceColumn
from typing import Optional, Set
from typing_extensions import Self

class DataSourceSheetProperties(BaseModel):
    """
    Additional properties of a DATA_SOURCE sheet.
    """ # noqa: E501
    columns: Optional[List[DataSourceColumn]] = Field(default=None, description="The columns displayed on the sheet, corresponding to the values in RowData.")
    data_execution_status: Optional[DataExecutionStatus] = Field(default=None, alias="dataExecutionStatus")
    data_source_id: Optional[StrictStr] = Field(default=None, description="ID of the DataSource the sheet is connected to.", alias="dataSourceId")
    __properties: ClassVar[List[str]] = ["columns", "dataExecutionStatus", "dataSourceId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataSourceSheetProperties from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in columns (list)
        _items = []
        if self.columns:
            for _item_columns in self.columns:
                if _item_columns:
                    _items.append(_item_columns.to_dict())
            _dict['columns'] = _items
        # override the default output from pydantic by calling `to_dict()` of data_execution_status
        if self.data_execution_status:
            _dict['dataExecutionStatus'] = self.data_execution_status.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataSourceSheetProperties from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "columns": [DataSourceColumn.from_dict(_item) for _item in obj["columns"]] if obj.get("columns") is not None else None,
            "dataExecutionStatus": DataExecutionStatus.from_dict(obj["dataExecutionStatus"]) if obj.get("dataExecutionStatus") is not None else None,
            "dataSourceId": obj.get("dataSourceId")
        })
        return _obj


