# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.big_query_data_source_spec import BigQueryDataSourceSpec
from google_sheets_ti.models.data_source_parameter import DataSourceParameter
from google_sheets_ti.models.looker_data_source_spec import LookerDataSourceSpec
from typing import Optional, Set
from typing_extensions import Self

class DataSourceSpec(BaseModel):
    """
    This specifies the details of the data source. For example, for BigQuery, this specifies information about the BigQuery source.
    """ # noqa: E501
    parameters: Optional[List[DataSourceParameter]] = Field(default=None, description="The parameters of the data source, used when querying the data source.")
    big_query: Optional[BigQueryDataSourceSpec] = Field(default=None, alias="bigQuery")
    looker: Optional[LookerDataSourceSpec] = None
    __properties: ClassVar[List[str]] = ["parameters", "bigQuery", "looker"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataSourceSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in parameters (list)
        _items = []
        if self.parameters:
            for _item_parameters in self.parameters:
                if _item_parameters:
                    _items.append(_item_parameters.to_dict())
            _dict['parameters'] = _items
        # override the default output from pydantic by calling `to_dict()` of big_query
        if self.big_query:
            _dict['bigQuery'] = self.big_query.to_dict()
        # override the default output from pydantic by calling `to_dict()` of looker
        if self.looker:
            _dict['looker'] = self.looker.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataSourceSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "parameters": [DataSourceParameter.from_dict(_item) for _item in obj["parameters"]] if obj.get("parameters") is not None else None,
            "bigQuery": BigQueryDataSourceSpec.from_dict(obj["bigQuery"]) if obj.get("bigQuery") is not None else None,
            "looker": LookerDataSourceSpec.from_dict(obj["looker"]) if obj.get("looker") is not None else None
        })
        return _obj


