# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.boolean_condition import BooleanCondition
from typing import Optional, Set
from typing_extensions import Self

class DataValidationRule(BaseModel):
    """
    A data validation rule.
    """ # noqa: E501
    condition: Optional[BooleanCondition] = None
    input_message: Optional[StrictStr] = Field(default=None, description="A message to show the user when adding data to the cell.", alias="inputMessage")
    show_custom_ui: Optional[StrictBool] = Field(default=None, description="True if the UI should be customized based on the kind of condition. If true, \"List\" conditions will show a dropdown.", alias="showCustomUi")
    strict: Optional[StrictBool] = Field(default=None, description="True if invalid data should be rejected.")
    __properties: ClassVar[List[str]] = ["condition", "inputMessage", "showCustomUi", "strict"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataValidationRule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of condition
        if self.condition:
            _dict['condition'] = self.condition.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataValidationRule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "condition": BooleanCondition.from_dict(obj["condition"]) if obj.get("condition") is not None else None,
            "inputMessage": obj.get("inputMessage"),
            "showCustomUi": obj.get("showCustomUi"),
            "strict": obj.get("strict")
        })
        return _obj


