# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.dimension_range import DimensionRange
from typing import Optional, Set
from typing_extensions import Self

class DeveloperMetadataLocation(BaseModel):
    """
    A location where metadata may be associated in a spreadsheet.
    """ # noqa: E501
    dimension_range: Optional[DimensionRange] = Field(default=None, alias="dimensionRange")
    location_type: Optional[StrictStr] = Field(default=None, description="The type of location this object represents. This field is read-only.", alias="locationType")
    sheet_id: Optional[StrictInt] = Field(default=None, description="The ID of the sheet when metadata is associated with an entire sheet.", alias="sheetId")
    spreadsheet: Optional[StrictBool] = Field(default=None, description="True when metadata is associated with an entire spreadsheet.")
    __properties: ClassVar[List[str]] = ["dimensionRange", "locationType", "sheetId", "spreadsheet"]

    @field_validator('location_type')
    def location_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['DEVELOPER_METADATA_LOCATION_TYPE_UNSPECIFIED', 'ROW', 'COLUMN', 'SHEET', 'SPREADSHEET']):
            raise ValueError("must be one of enum values ('DEVELOPER_METADATA_LOCATION_TYPE_UNSPECIFIED', 'ROW', 'COLUMN', 'SHEET', 'SPREADSHEET')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DeveloperMetadataLocation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of dimension_range
        if self.dimension_range:
            _dict['dimensionRange'] = self.dimension_range.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DeveloperMetadataLocation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dimensionRange": DimensionRange.from_dict(obj["dimensionRange"]) if obj.get("dimensionRange") is not None else None,
            "locationType": obj.get("locationType"),
            "sheetId": obj.get("sheetId"),
            "spreadsheet": obj.get("spreadsheet")
        })
        return _obj


