# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.data_source_column_reference import DataSourceColumnReference
from google_sheets_ti.models.developer_metadata import DeveloperMetadata
from typing import Optional, Set
from typing_extensions import Self

class DimensionProperties(BaseModel):
    """
    Properties about a dimension.
    """ # noqa: E501
    data_source_column_reference: Optional[DataSourceColumnReference] = Field(default=None, alias="dataSourceColumnReference")
    developer_metadata: Optional[List[DeveloperMetadata]] = Field(default=None, description="The developer metadata associated with a single row or column.", alias="developerMetadata")
    hidden_by_filter: Optional[StrictBool] = Field(default=None, description="True if this dimension is being filtered. This field is read-only.", alias="hiddenByFilter")
    hidden_by_user: Optional[StrictBool] = Field(default=None, description="True if this dimension is explicitly hidden.", alias="hiddenByUser")
    pixel_size: Optional[StrictInt] = Field(default=None, description="The height (if a row) or width (if a column) of the dimension in pixels.", alias="pixelSize")
    __properties: ClassVar[List[str]] = ["dataSourceColumnReference", "developerMetadata", "hiddenByFilter", "hiddenByUser", "pixelSize"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DimensionProperties from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of data_source_column_reference
        if self.data_source_column_reference:
            _dict['dataSourceColumnReference'] = self.data_source_column_reference.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in developer_metadata (list)
        _items = []
        if self.developer_metadata:
            for _item_developer_metadata in self.developer_metadata:
                if _item_developer_metadata:
                    _items.append(_item_developer_metadata.to_dict())
            _dict['developerMetadata'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DimensionProperties from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dataSourceColumnReference": DataSourceColumnReference.from_dict(obj["dataSourceColumnReference"]) if obj.get("dataSourceColumnReference") is not None else None,
            "developerMetadata": [DeveloperMetadata.from_dict(_item) for _item in obj["developerMetadata"]] if obj.get("developerMetadata") is not None else None,
            "hiddenByFilter": obj.get("hiddenByFilter"),
            "hiddenByUser": obj.get("hiddenByUser"),
            "pixelSize": obj.get("pixelSize")
        })
        return _obj


