# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.overlay_position import OverlayPosition
from typing import Optional, Set
from typing_extensions import Self

class EmbeddedObjectPosition(BaseModel):
    """
    The position of an embedded object such as a chart.
    """ # noqa: E501
    new_sheet: Optional[StrictBool] = Field(default=None, description="If true, the embedded object is put on a new sheet whose ID is chosen for you. Used only when writing.", alias="newSheet")
    overlay_position: Optional[OverlayPosition] = Field(default=None, alias="overlayPosition")
    sheet_id: Optional[StrictInt] = Field(default=None, description="The sheet this is on. Set only if the embedded object is on its own sheet. Must be non-negative.", alias="sheetId")
    __properties: ClassVar[List[str]] = ["newSheet", "overlayPosition", "sheetId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EmbeddedObjectPosition from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of overlay_position
        if self.overlay_position:
            _dict['overlayPosition'] = self.overlay_position.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EmbeddedObjectPosition from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "newSheet": obj.get("newSheet"),
            "overlayPosition": OverlayPosition.from_dict(obj["overlayPosition"]) if obj.get("overlayPosition") is not None else None,
            "sheetId": obj.get("sheetId")
        })
        return _obj


