# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from google_sheets_ti.models.error_value import ErrorValue
from typing import Optional, Set
from typing_extensions import Self

class ExtendedValue(BaseModel):
    """
    The kinds of value that a cell in a spreadsheet can have.
    """ # noqa: E501
    bool_value: Optional[StrictBool] = Field(default=None, description="Represents a boolean value.", alias="boolValue")
    error_value: Optional[ErrorValue] = Field(default=None, alias="errorValue")
    formula_value: Optional[StrictStr] = Field(default=None, description="Represents a formula.", alias="formulaValue")
    number_value: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Represents a double value. Note: Dates, Times and DateTimes are represented as doubles in SERIAL_NUMBER format.", alias="numberValue")
    string_value: Optional[StrictStr] = Field(default=None, description="Represents a string value. Leading single quotes are not included. For example, if the user typed `'123` into the UI, this would be represented as a `stringValue` of `\"123\"`.", alias="stringValue")
    __properties: ClassVar[List[str]] = ["boolValue", "errorValue", "formulaValue", "numberValue", "stringValue"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExtendedValue from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of error_value
        if self.error_value:
            _dict['errorValue'] = self.error_value.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExtendedValue from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "boolValue": obj.get("boolValue"),
            "errorValue": ErrorValue.from_dict(obj["errorValue"]) if obj.get("errorValue") is not None else None,
            "formulaValue": obj.get("formulaValue"),
            "numberValue": obj.get("numberValue"),
            "stringValue": obj.get("stringValue")
        })
        return _obj


