# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.dimension_properties import DimensionProperties
from google_sheets_ti.models.row_data import RowData
from typing import Optional, Set
from typing_extensions import Self

class GridData(BaseModel):
    """
    Data in the grid, as well as metadata about the dimensions.
    """ # noqa: E501
    column_metadata: Optional[List[DimensionProperties]] = Field(default=None, description="Metadata about the requested columns in the grid, starting with the column in start_column.", alias="columnMetadata")
    row_data: Optional[List[RowData]] = Field(default=None, description="The data in the grid, one entry per row, starting with the row in startRow. The values in RowData will correspond to columns starting at start_column.", alias="rowData")
    row_metadata: Optional[List[DimensionProperties]] = Field(default=None, description="Metadata about the requested rows in the grid, starting with the row in start_row.", alias="rowMetadata")
    start_column: Optional[StrictInt] = Field(default=None, description="The first column this GridData refers to, zero-based.", alias="startColumn")
    start_row: Optional[StrictInt] = Field(default=None, description="The first row this GridData refers to, zero-based.", alias="startRow")
    __properties: ClassVar[List[str]] = ["columnMetadata", "rowData", "rowMetadata", "startColumn", "startRow"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GridData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in column_metadata (list)
        _items = []
        if self.column_metadata:
            for _item_column_metadata in self.column_metadata:
                if _item_column_metadata:
                    _items.append(_item_column_metadata.to_dict())
            _dict['columnMetadata'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in row_data (list)
        _items = []
        if self.row_data:
            for _item_row_data in self.row_data:
                if _item_row_data:
                    _items.append(_item_row_data.to_dict())
            _dict['rowData'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in row_metadata (list)
        _items = []
        if self.row_metadata:
            for _item_row_metadata in self.row_metadata:
                if _item_row_metadata:
                    _items.append(_item_row_metadata.to_dict())
            _dict['rowMetadata'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GridData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "columnMetadata": [DimensionProperties.from_dict(_item) for _item in obj["columnMetadata"]] if obj.get("columnMetadata") is not None else None,
            "rowData": [RowData.from_dict(_item) for _item in obj["rowData"]] if obj.get("rowData") is not None else None,
            "rowMetadata": [DimensionProperties.from_dict(_item) for _item in obj["rowMetadata"]] if obj.get("rowMetadata") is not None else None,
            "startColumn": obj.get("startColumn"),
            "startRow": obj.get("startRow")
        })
        return _obj


