# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class LineStyle(BaseModel):
    """
    Properties that describe the style of a line.
    """ # noqa: E501
    type: Optional[StrictStr] = Field(default=None, description="The dash type of the line.")
    width: Optional[StrictInt] = Field(default=None, description="The thickness of the line, in px.")
    __properties: ClassVar[List[str]] = ["type", "width"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['LINE_DASH_TYPE_UNSPECIFIED', 'INVISIBLE', 'CUSTOM', 'SOLID', 'DOTTED', 'MEDIUM_DASHED', 'MEDIUM_DASHED_DOTTED', 'LONG_DASHED', 'LONG_DASHED_DOTTED']):
            raise ValueError("must be one of enum values ('LINE_DASH_TYPE_UNSPECIFIED', 'INVISIBLE', 'CUSTOM', 'SOLID', 'DOTTED', 'MEDIUM_DASHED', 'MEDIUM_DASHED_DOTTED', 'LONG_DASHED', 'LONG_DASHED_DOTTED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LineStyle from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LineStyle from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "width": obj.get("width")
        })
        return _obj


