# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RefreshCancellationStatus(BaseModel):
    """
    The status of a refresh cancellation. You can send a cancel request to explicitly cancel one or multiple data source object refreshes.
    """ # noqa: E501
    error_code: Optional[StrictStr] = Field(default=None, description="The error code.", alias="errorCode")
    state: Optional[StrictStr] = Field(default=None, description="The state of a call to cancel a refresh in Sheets.")
    __properties: ClassVar[List[str]] = ["errorCode", "state"]

    @field_validator('error_code')
    def error_code_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['REFRESH_CANCELLATION_ERROR_CODE_UNSPECIFIED', 'EXECUTION_NOT_FOUND', 'CANCEL_PERMISSION_DENIED', 'QUERY_EXECUTION_COMPLETED', 'CONCURRENT_CANCELLATION', 'CANCEL_OTHER_ERROR']):
            raise ValueError("must be one of enum values ('REFRESH_CANCELLATION_ERROR_CODE_UNSPECIFIED', 'EXECUTION_NOT_FOUND', 'CANCEL_PERMISSION_DENIED', 'QUERY_EXECUTION_COMPLETED', 'CONCURRENT_CANCELLATION', 'CANCEL_OTHER_ERROR')")
        return value

    @field_validator('state')
    def state_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['REFRESH_CANCELLATION_STATE_UNSPECIFIED', 'CANCEL_SUCCEEDED', 'CANCEL_FAILED']):
            raise ValueError("must be one of enum values ('REFRESH_CANCELLATION_STATE_UNSPECIFIED', 'CANCEL_SUCCEEDED', 'CANCEL_FAILED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RefreshCancellationStatus from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RefreshCancellationStatus from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "errorCode": obj.get("errorCode"),
            "state": obj.get("state")
        })
        return _obj


