# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.matched_developer_metadata import MatchedDeveloperMetadata
from typing import Optional, Set
from typing_extensions import Self

class SearchDeveloperMetadataResponse(BaseModel):
    """
    A reply to a developer metadata search request.
    """ # noqa: E501
    matched_developer_metadata: Optional[List[MatchedDeveloperMetadata]] = Field(default=None, description="The metadata matching the criteria of the search request.", alias="matchedDeveloperMetadata")
    __properties: ClassVar[List[str]] = ["matchedDeveloperMetadata"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SearchDeveloperMetadataResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in matched_developer_metadata (list)
        _items = []
        if self.matched_developer_metadata:
            for _item_matched_developer_metadata in self.matched_developer_metadata:
                if _item_matched_developer_metadata:
                    _items.append(_item_matched_developer_metadata.to_dict())
            _dict['matchedDeveloperMetadata'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SearchDeveloperMetadataResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "matchedDeveloperMetadata": [MatchedDeveloperMetadata.from_dict(_item) for _item in obj["matchedDeveloperMetadata"]] if obj.get("matchedDeveloperMetadata") is not None else None
        })
        return _obj


