# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.color import Color
from google_sheets_ti.models.color_style import ColorStyle
from google_sheets_ti.models.filter_criteria import FilterCriteria
from google_sheets_ti.models.grid_range import GridRange
from google_sheets_ti.models.text_format import TextFormat
from typing import Optional, Set
from typing_extensions import Self

class SlicerSpec(BaseModel):
    """
    The specifications of a slicer.
    """ # noqa: E501
    apply_to_pivot_tables: Optional[StrictBool] = Field(default=None, description="True if the filter should apply to pivot tables. If not set, default to `True`.", alias="applyToPivotTables")
    background_color: Optional[Color] = Field(default=None, alias="backgroundColor")
    background_color_style: Optional[ColorStyle] = Field(default=None, alias="backgroundColorStyle")
    column_index: Optional[StrictInt] = Field(default=None, description="The zero-based column index in the data table on which the filter is applied to.", alias="columnIndex")
    data_range: Optional[GridRange] = Field(default=None, alias="dataRange")
    filter_criteria: Optional[FilterCriteria] = Field(default=None, alias="filterCriteria")
    horizontal_alignment: Optional[StrictStr] = Field(default=None, description="The horizontal alignment of title in the slicer. If unspecified, defaults to `LEFT`", alias="horizontalAlignment")
    text_format: Optional[TextFormat] = Field(default=None, alias="textFormat")
    title: Optional[StrictStr] = Field(default=None, description="The title of the slicer.")
    __properties: ClassVar[List[str]] = ["applyToPivotTables", "backgroundColor", "backgroundColorStyle", "columnIndex", "dataRange", "filterCriteria", "horizontalAlignment", "textFormat", "title"]

    @field_validator('horizontal_alignment')
    def horizontal_alignment_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['HORIZONTAL_ALIGN_UNSPECIFIED', 'LEFT', 'CENTER', 'RIGHT']):
            raise ValueError("must be one of enum values ('HORIZONTAL_ALIGN_UNSPECIFIED', 'LEFT', 'CENTER', 'RIGHT')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SlicerSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of background_color
        if self.background_color:
            _dict['backgroundColor'] = self.background_color.to_dict()
        # override the default output from pydantic by calling `to_dict()` of background_color_style
        if self.background_color_style:
            _dict['backgroundColorStyle'] = self.background_color_style.to_dict()
        # override the default output from pydantic by calling `to_dict()` of data_range
        if self.data_range:
            _dict['dataRange'] = self.data_range.to_dict()
        # override the default output from pydantic by calling `to_dict()` of filter_criteria
        if self.filter_criteria:
            _dict['filterCriteria'] = self.filter_criteria.to_dict()
        # override the default output from pydantic by calling `to_dict()` of text_format
        if self.text_format:
            _dict['textFormat'] = self.text_format.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SlicerSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "applyToPivotTables": obj.get("applyToPivotTables"),
            "backgroundColor": Color.from_dict(obj["backgroundColor"]) if obj.get("backgroundColor") is not None else None,
            "backgroundColorStyle": ColorStyle.from_dict(obj["backgroundColorStyle"]) if obj.get("backgroundColorStyle") is not None else None,
            "columnIndex": obj.get("columnIndex"),
            "dataRange": GridRange.from_dict(obj["dataRange"]) if obj.get("dataRange") is not None else None,
            "filterCriteria": FilterCriteria.from_dict(obj["filterCriteria"]) if obj.get("filterCriteria") is not None else None,
            "horizontalAlignment": obj.get("horizontalAlignment"),
            "textFormat": TextFormat.from_dict(obj["textFormat"]) if obj.get("textFormat") is not None else None,
            "title": obj.get("title")
        })
        return _obj


