# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.theme_color_pair import ThemeColorPair
from typing import Optional, Set
from typing_extensions import Self

class SpreadsheetTheme(BaseModel):
    """
    Represents spreadsheet theme
    """ # noqa: E501
    primary_font_family: Optional[StrictStr] = Field(default=None, description="Name of the primary font family.", alias="primaryFontFamily")
    theme_colors: Optional[List[ThemeColorPair]] = Field(default=None, description="The spreadsheet theme color pairs. To update you must provide all theme color pairs.", alias="themeColors")
    __properties: ClassVar[List[str]] = ["primaryFontFamily", "themeColors"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SpreadsheetTheme from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in theme_colors (list)
        _items = []
        if self.theme_colors:
            for _item_theme_colors in self.theme_colors:
                if _item_theme_colors:
                    _items.append(_item_theme_colors.to_dict())
            _dict['themeColors'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SpreadsheetTheme from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "primaryFontFamily": obj.get("primaryFontFamily"),
            "themeColors": [ThemeColorPair.from_dict(_item) for _item in obj["themeColors"]] if obj.get("themeColors") is not None else None
        })
        return _obj


