# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.data_filter import DataFilter
from google_sheets_ti.models.developer_metadata import DeveloperMetadata
from typing import Optional, Set
from typing_extensions import Self

class UpdateDeveloperMetadataRequest(BaseModel):
    """
    A request to update properties of developer metadata. Updates the properties of the developer metadata selected by the filters to the values provided in the DeveloperMetadata resource. Callers must specify the properties they wish to update in the fields parameter, as well as specify at least one DataFilter matching the metadata they wish to update.
    """ # noqa: E501
    data_filters: Optional[List[DataFilter]] = Field(default=None, description="The filters matching the developer metadata entries to update.", alias="dataFilters")
    developer_metadata: Optional[DeveloperMetadata] = Field(default=None, alias="developerMetadata")
    fields: Optional[StrictStr] = Field(default=None, description="The fields that should be updated. At least one field must be specified. The root `developerMetadata` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.")
    __properties: ClassVar[List[str]] = ["dataFilters", "developerMetadata", "fields"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateDeveloperMetadataRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in data_filters (list)
        _items = []
        if self.data_filters:
            for _item_data_filters in self.data_filters:
                if _item_data_filters:
                    _items.append(_item_data_filters.to_dict())
            _dict['dataFilters'] = _items
        # override the default output from pydantic by calling `to_dict()` of developer_metadata
        if self.developer_metadata:
            _dict['developerMetadata'] = self.developer_metadata.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateDeveloperMetadataRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dataFilters": [DataFilter.from_dict(_item) for _item in obj["dataFilters"]] if obj.get("dataFilters") is not None else None,
            "developerMetadata": DeveloperMetadata.from_dict(obj["developerMetadata"]) if obj.get("developerMetadata") is not None else None,
            "fields": obj.get("fields")
        })
        return _obj


