# coding: utf-8

"""
    Google Sheets API

    Reads and writes Google Sheets.

    The version of the OpenAPI document: v4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_sheets_ti.models.data_source_sheet_dimension_range import DataSourceSheetDimensionRange
from google_sheets_ti.models.dimension_properties import DimensionProperties
from google_sheets_ti.models.dimension_range import DimensionRange
from typing import Optional, Set
from typing_extensions import Self

class UpdateDimensionPropertiesRequest(BaseModel):
    """
    Updates properties of dimensions within the specified range.
    """ # noqa: E501
    data_source_sheet_range: Optional[DataSourceSheetDimensionRange] = Field(default=None, alias="dataSourceSheetRange")
    fields: Optional[StrictStr] = Field(default=None, description="The fields that should be updated. At least one field must be specified. The root `properties` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.")
    properties: Optional[DimensionProperties] = None
    range: Optional[DimensionRange] = None
    __properties: ClassVar[List[str]] = ["dataSourceSheetRange", "fields", "properties", "range"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateDimensionPropertiesRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of data_source_sheet_range
        if self.data_source_sheet_range:
            _dict['dataSourceSheetRange'] = self.data_source_sheet_range.to_dict()
        # override the default output from pydantic by calling `to_dict()` of properties
        if self.properties:
            _dict['properties'] = self.properties.to_dict()
        # override the default output from pydantic by calling `to_dict()` of range
        if self.range:
            _dict['range'] = self.range.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateDimensionPropertiesRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dataSourceSheetRange": DataSourceSheetDimensionRange.from_dict(obj["dataSourceSheetRange"]) if obj.get("dataSourceSheetRange") is not None else None,
            "fields": obj.get("fields"),
            "properties": DimensionProperties.from_dict(obj["properties"]) if obj.get("properties") is not None else None,
            "range": DimensionRange.from_dict(obj["range"]) if obj.get("range") is not None else None
        })
        return _obj


